package exercises;

import java.util.Optional;
import java.util.stream.Stream;

/**
 * Übung für JUGS-Java9-Workshop
 * 
 * @author Michael Inden
 * 
 * Copyright 2016 by Michael Inden 
 */
public class Exercise6_Optional
{
    public static void main(final String[] args)
    {
        findJdk8();
        findJdk9();
    }

    private static void findJdk9()
    {
        System.out.println("findJdk8");
        
        final Optional<Person> opt = findPersonByName("Tim");
        // TODO
        
        final Optional<Person> opt2 = findPersonByName("UNKNOWN");
        // TODO
    }

    private static void findJdk8()
    {
        System.out.println("findJdk8");

        final Optional<Person> opt = findPersonByName("Tim");
        if (opt.isPresent())
        {
            doHappyCase(opt.get());
        }
        else
        {
            doErrorCase();
        }

        final Optional<Person> opt2 = findPersonByName("UNKNOWN");
        if (opt2.isPresent())
        {
            doHappyCase(opt2.get());
        }
        else
        {
            doErrorCase();
        }
    }

    private static Optional<Person> findPersonByName(final String searchFor)
    {
        final Stream<Person> persons = Stream.of(new Person("Mike"), new Person("Tim"), new Person("Tom"));

        return persons.filter(person -> person.getName().equals(searchFor)).findFirst();
    }

    private static void doHappyCase(final Person person)
    {
        System.out.println("Result: " + person);
    }

    private static void doErrorCase()
    {
        System.out.println("not found");
    }

    static class Person
    {
        private final String name;

        public Person(String name)
        {
            this.name = name;
        }

        public String getName()
        {
            return name;
        }

        @Override
        public String toString()
        {
            return "Person: " + getName();
        }
    }
}
