package exercises;

import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.List;
import java.util.concurrent.Flow;
import java.util.concurrent.Flow.Subscriber;
import java.util.concurrent.SubmissionPublisher;

/**
 * Übung für JUGS-Java9-Workshop
 * 
 * @author Michael Inden
 * 
 * Copyright 2016 by Michael Inden 
 */
public class Exercise9_WordPublisher implements Flow.Publisher<String>
{
    private final SubmissionPublisher<String> publisher;   
    private final Path path = Paths.get("./resources/input.txt");
    
    public Exercise9_WordPublisher()
    {
        this.publisher = new SubmissionPublisher<>();
    }

    @Override
    public void subscribe(final Subscriber<? super String> subscriber)
    {
        publisher.subscribe(subscriber);        
    }
    
    public void doWork() throws IOException
    {
        final Charset utf8 = StandardCharsets.UTF_8;
        final List<String> lines = Files.readAllLines(path, utf8);
               
        for (int i = 0; i <  lines.size(); i++)
        {
        	publisher.submit("line: " + i +  " : " + lines.get(i));
        }
    }
}
