package solutions;

import java.util.function.Predicate;
import java.util.stream.Stream;

/**
 * Beispiellösung für JUGS-Java9-Workshop
 * 
 * @author Michael Inden
 * 
 * Copyright 2016 by Michael Inden 
 */
public class Exercise4_Streams
{
    public static void main(String[] args)
    {
        final Stream<String> values1 = Stream.of("a", "b", "c", "", "e", "f");
        final Stream<Integer> values2 = Stream.of(1, 2, 3, 11, 22, 33, 7, 10);
        final Stream<Integer> values3 = Stream.of(1, 2, 3, 11, 22, 33, 7, 10);

        final Predicate<String> isEmpty = String::isEmpty;
        final Predicate<String> notEmpty = isEmpty.negate();

        System.out.println("takeWhile");
        values1.takeWhile(notEmpty).forEach(System.out::println);

        System.out.println("\ndropWhile");
        values2.dropWhile(i -> i < 10).forEach(System.out::println);
        
        System.out.println("\nwith filter");
        values3.filter(i -> i >= 10).forEach(System.out::println);
    }
}
