package solutions;

import java.util.concurrent.Flow.Subscriber;
import java.util.concurrent.Flow.Subscription;
import java.util.function.Consumer;

/**
 * Übung für JUGS-Java9-Workshop
 * 
 * @author Michael Inden
 * 
 * Copyright 2016 by Michael Inden 
 */
class Exercise9_SkipAndTakeSubscriber implements Subscriber<String>
{
    final Consumer<String> consumer;

    private Subscription   subscription;

    private int count = 0;
    private final int skip;
    private final int take;

    Exercise9_SkipAndTakeSubscriber(final Consumer<String> consumer, final int skip, final int take)
    {
        this.consumer = consumer;
        this.skip = skip;
        this.take = take;
    }

    @Override
    public void onSubscribe(final Subscription subscription)
    {
        System.err.println("SkipAndTakeSubscriber - Subscription: " + subscription);
        this.subscription = subscription;
        this.subscription.request(skip + take);
    }

    @Override
    public void onError(final Throwable throwable)
    {
        throwable.printStackTrace();
    }

    @Override
    public void onNext(final String item)
    {
        count++;
        System.err.println("SkipAndTakeSubscriber " + count + " x onNext()");
        
        if (count >= skip)
        {
        	consumer.accept(item);
        }

        if (count >= skip + take - 1)
        {
            subscription.cancel();
        }       
    }

    @Override
    public void onComplete()
    {
        System.err.println("onComplete()");
    }
}